Index: mtp3.c
===================================================================
--- mtp3.c	(revision 285)
+++ mtp3.c	(working copy)
@@ -1072,12 +1072,29 @@
 	
 }
 
+static int net_mng_uses_sls(unsigned char msg)
+{
+	switch (msg) {
+		case NET_MNG_TRA:
+		case NET_MNG_TFP:
+			return 0;
+		default:
+			return 1;
+		}
+}
+
+static struct mtp2 * first_mtp2(struct ss7 *ss7)
+{
+	return ss7->numlinks > 0 ? ss7->links[0] : NULL;
+}
+
+
 static int net_mng_receive(struct ss7 *ss7, struct mtp2 *mtp2, struct routing_label *rl, unsigned char *buf, int len)
 {
 	unsigned char *headerptr = buf + rl_size(ss7);
 	unsigned char *paramptr = headerptr + 1;
 	struct routing_label rlr;
-	struct mtp2 *winner = slc_to_mtp2(mtp2->master, rl->sls);
+	struct mtp2 *winner = net_mng_uses_sls(*headerptr) ? slc_to_mtp2(mtp2->master, rl->sls) : first_mtp2(mtp2->master);
 
 	if (!winner) {
 		/* Could not find the given slc */
